import Test.QuickCheck
import Text.Printf
import Data.Number.Nat
import Data.Number.NatO
import qualified Data.Number.Int as Int


main  = mapM_ (\(s,a) -> printf "%-25s: " s >> a) tests

prop_binOpNat :: (Nat -> Nat -> Nat) -> (Int -> Int -> Int) 
              -> (Int -> Int -> Bool) -> Int -> Int -> Property
prop_binOpNat op1 op2 p m n = 
  p m n ==> 
    fromEnum (op1 (toEnum m :: Nat) (toEnum n :: Nat)) == (op2 m n :: Int)

prop_binOpNatO :: (NatO -> NatO -> NatO) -> (Int -> Int -> Int) 
               -> (Int -> Int -> Bool) -> Int -> Int -> Property
prop_binOpNatO op1 op2 p m n =
  p m n ==> 
    fromEnum (op1 (toEnum m :: NatO) (toEnum n :: NatO)) == (op2 m n :: Int)

prop_binOpInt :: (Int.Int -> Int.Int -> Int.Int) -> (Int -> Int -> Int) -> Int 
              -> Int -> Bool
prop_binOpInt op1 op2 m n =
  fromEnum (op1 (toEnum m :: Int.Int) (toEnum n :: Int.Int)) == (op2 m n :: Int)

isNat :: Int -> Bool
isNat = (>0)

isNatO :: Int -> Bool
isNatO = (>=0)

areNats :: Int -> Int -> Bool
areNats m n = isNat m && isNat n

areNatOs :: Int -> Int -> Bool
areNatOs m n = isNatO m && isNatO n

true :: Int -> Int -> Bool
true _ _ = True

posNat :: Int -> Int -> Bool
posNat m n = areNats m n && m>n

posNatO :: Int -> Int -> Bool
posNatO m n = areNatOs m n && m>=n


tests = 
  [("mult :: Nat",test (prop_binOpNat (*) (*) areNats))
  ,("mult :: NatO",test (prop_binOpNatO (*) (*) areNatOs))
  ,("mult :: Int",test (prop_binOpInt (*) (*)))
  ,("add :: Nat",test (prop_binOpNat (+) (+) areNats))
  ,("add :: NatO",test (prop_binOpNatO (+) (+) areNatOs))
  ,("add :: Int",test (prop_binOpInt (+) (+)))
  ,("minus :: Nat",test (prop_binOpNat (-) (-) posNat))
  ,("minus :: NatO",test (prop_binOpNatO (-) (-) posNatO))
  ,("minus :: Int",test (prop_binOpInt (-) (-)))
  ]
